org.apache.xpath.operations

## Class UnaryOperation

- java.lang.Object
- - org.apache.xpath.Expression
  - - org.apache.xpath.operations.UnaryOperation

All Implemented Interfaces:
  java.io.Serializable, SourceLocator, ExpressionNode, ExpressionOwner, XPathVisitable

Direct Known Subclasses:
  Bool, Neg, Number, String

    public abstract class UnaryOperation
    extends Expression
    implements ExpressionOwner

The unary operation base class.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`UnaryOperation()`

### Method Summary

Methods
`void` `callVisitors(ExpressionOwner owner, XPathVisitor visitor)` This will traverse the heararchy, calling the visitor for each member.
`boolean` `canTraverseOutsideSubtree()` Tell if this expression or it's subexpressions can traverse outside the current subtree.
`boolean` `deepEquals(Expression expr)` Compare this object with another object and see if they are equal, include the sub heararchy.
`XObject` `execute(XPathContext xctxt)` Execute the operand and apply the unary operation to the result.
`void` `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
`Expression` `getExpression()` Get the raw Expression object that this class wraps.
`Expression` `getOperand()`
`abstract XObject` `operate(XObject right)` Apply the operation to two operands, and return the result.
`void` `setExpression(Expression exp)` Set the raw expression object for this object.
`void` `setRight(Expression r)` Set the expression operand for the operation.

### Methods inherited from class org.apache.xpath.Expression

`asIterator, asIteratorRaw, asNode, assertion, bool, error, execute, execute, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### UnaryOperation

    public UnaryOperation()

### Method Detail

#### fixupVariables

    public void fixupVariables(java.util.Vector vars,
                      int globalsSize)

This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.

Specified by:
  `fixupVariables` in class `Expression`
Parameters:
  `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame).

#### canTraverseOutsideSubtree

    public boolean canTraverseOutsideSubtree()

Tell if this expression or it's subexpressions can traverse outside the current subtree.

Overrides:
  `canTraverseOutsideSubtree` in class `Expression`
Returns:
  true if traversal outside the context node's subtree can occur.

#### setRight

    public void setRight(Expression r)

Set the expression operand for the operation.

Parameters:
  `r` - The expression operand to which the unary operation will be applied.

#### execute

    public XObject execute(XPathContext xctxt)
                    throws TransformerException

Execute the operand and apply the unary operation to the result.

Specified by:
  `execute` in class `Expression`
Parameters:
  `xctxt` - The runtime execution context.
Returns:
  An XObject that represents the result of applying the unary operation to the evaluated operand.
Throws:
  `TransformerException`

#### operate

    public abstract XObject operate(XObject right)
                             throws TransformerException

Apply the operation to two operands, and return the result.

Parameters:
  `right` - non-null reference to the evaluated right operand.
Returns:
  non-null reference to the XObject that represents the result of the operation.
Throws:
  `TransformerException`

#### getOperand

    public Expression getOperand()

Returns:
  the operand of unary operation, as an Expression.

#### callVisitors

    public void callVisitors(ExpressionOwner owner,
                    XPathVisitor visitor)

Description copied from interface: `XPathVisitable`
This will traverse the heararchy, calling the visitor for each member. If the called visitor method returns false, the subtree should not be called.

Specified by:
  `callVisitors` in interface `XPathVisitable`
Parameters:
  `owner` - The owner of the visitor, where that path may be rewritten if needed.
  `visitor` - The visitor whose appropriate method will be called.
See Also:
  `XPathVisitable.callVisitors(ExpressionOwner, XPathVisitor)`

#### getExpression

    public Expression getExpression()

Description copied from interface: `ExpressionOwner`
Get the raw Expression object that this class wraps.

Specified by:
  `getExpression` in interface `ExpressionOwner`
Returns:
  the raw Expression object, which should not normally be null.
See Also:
  `ExpressionOwner.getExpression()`

#### setExpression

    public void setExpression(Expression exp)

Description copied from interface: `ExpressionOwner`
Set the raw expression object for this object.

Specified by:
  `setExpression` in interface `ExpressionOwner`
Parameters:
  `exp` - the raw Expression object, which should not normally be null.
See Also:
  `ExpressionOwner.setExpression(Expression)`

#### deepEquals

    public boolean deepEquals(Expression expr)

Description copied from class: `Expression`
Compare this object with another object and see if they are equal, include the sub heararchy.

Specified by:
  `deepEquals` in class `Expression`
Parameters:
  `expr` - Another expression object.
Returns:
  true if this objects class and the expr object's class are the same, and the data contained within both objects are considered equal.
See Also:
  `Expression.deepEquals(Expression)`